/* Mecanime de Apelare (de Transfer) in C++:
 * 
 * 1. Apel "Prin Valoare"
 * 
 * 2. Apel "Prin Referinta"
 * 
 */ 
#include <iostream>
using namespace std;

void Citeste(int& b); // b este param. "Tip Referinta" sau "De Iesire"
void Scrie(int b);    // b este param. "Tip Valoare" sau "De Intrare" 

/* Subprogramul apelat (functie) poate returna valori
 * in subprogramul apelant, prin parametri de iesire.
 */ 


int main()
{
	int a = 283;
	
	Citeste(a); // Apel "Prin Referinta" (argumentul se poate modifica)
	
	Scrie(a);   // Apel "Prin Valoare" (argumentul NU se poate modifica)
	
	return 0;
}

void Citeste(int& b) // b este "O referinta la o variabila de tip int, numita "a"
{     			     // b este un "ALIAS", un "Alt Nume" pentru variabila "a" 
	cin >> b;        // de fapt, b este CHIAR a 
}

void Scrie(int b)
{
	cout << b;
}
